From 454870ce5d6520ef5adc864ec62b21f968ad7e9c Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Thu, 9 Jan 2014 15:31:48 -0500
Subject: [PATCH 123/159] FIXME: set_new_first_and_last_insn,
 push_to_sequence2, cfg_layout_function_header

---
 gcc/builtins.c | 2 +-
 gcc/cfgrtl.c   | 6 +++---
 gcc/emit-rtl.c | 6 +++---
 gcc/optabs.c   | 6 +++---
 gcc/rtl.h      | 4 ++--
 5 files changed, 12 insertions(+), 12 deletions(-)

diff --git a/gcc/builtins.c b/gcc/builtins.c
index 2119adc..6e470a7 100644
--- a/gcc/builtins.c
+++ b/gcc/builtins.c
@@ -1756,7 +1756,7 @@ expand_builtin_return (rtx result)
   int size, align, regno;
   enum machine_mode mode;
   rtx reg;
-  rtx call_fusage = 0;
+  rtx_base_insn call_fusage = 0;
 
   result = convert_memory_address (Pmode, result);
 
diff --git a/gcc/cfgrtl.c b/gcc/cfgrtl.c
index 2a2f806..c0c0c44 100644
--- a/gcc/cfgrtl.c
+++ b/gcc/cfgrtl.c
@@ -65,7 +65,7 @@ along with GCC; see the file COPYING3.  If not see
 /* Holds the interesting leading and trailing notes for the function.
    Only applicable if the CFG is in cfglayout mode.  */
 static GTY(()) rtx_base_insn cfg_layout_function_footer;
-static GTY(()) rtx cfg_layout_function_header;
+static GTY(()) rtx_base_insn cfg_layout_function_header;
 
 static rtx_base_insn skip_insns_after_block (basic_block);
 static void record_effective_endpoints (void);
@@ -3462,7 +3462,7 @@ record_effective_endpoints (void)
     cfg_layout_function_header =
 	    unlink_insn_chain (get_insns (), PREV_INSN (insn));
   else
-    cfg_layout_function_header = NULL_RTX;
+    cfg_layout_function_header = NULL_RTX_BASE_INSN;
 
   next_insn = get_insns ();
   FOR_EACH_BB (bb)
@@ -3663,7 +3663,7 @@ static void
 fixup_reorder_chain (void)
 {
   basic_block bb;
-  rtx insn = NULL;
+  rtx_base_insn insn = NULL;
 
   if (cfg_layout_function_header)
     {
diff --git a/gcc/emit-rtl.c b/gcc/emit-rtl.c
index 5013b36..5ae7847 100644
--- a/gcc/emit-rtl.c
+++ b/gcc/emit-rtl.c
@@ -2405,9 +2405,9 @@ gen_label_rtx (void)
    Used for an inline-procedure after copying the insn chain.  */
 
 void
-set_new_first_and_last_insn (rtx first, rtx last)
+set_new_first_and_last_insn (rtx_base_insn first, rtx_base_insn last)
 {
-  rtx insn;
+  rtx_base_insn insn;
 
   set_first_insn (first);
   set_last_insn (last);
@@ -5248,7 +5248,7 @@ push_to_sequence (rtx first)
    looping through the list.  */
 
 void
-push_to_sequence2 (rtx first, rtx last)
+push_to_sequence2 (rtx_base_insn first, rtx_base_insn last)
 {
   start_sequence ();
 
diff --git a/gcc/optabs.c b/gcc/optabs.c
index d10b554..e6a0a71 100644
--- a/gcc/optabs.c
+++ b/gcc/optabs.c
@@ -1836,7 +1836,7 @@ expand_binop (enum machine_mode mode, optab binoptab, rtx op0, rtx op1,
       && optab_handler (ashl_optab, word_mode) != CODE_FOR_nothing
       && optab_handler (lshr_optab, word_mode) != CODE_FOR_nothing)
     {
-      rtx insns;
+      rtx_base_insn insns;
       rtx into_target, outof_target;
       rtx into_input, outof_input;
       rtx inter;
@@ -2121,7 +2121,7 @@ expand_binop (enum machine_mode mode, optab binoptab, rtx op0, rtx op1,
   if (libfunc
       && (methods == OPTAB_LIB || methods == OPTAB_LIB_WIDEN))
     {
-      rtx insns;
+      rtx_base_insn insns;
       rtx op1x = op1;
       enum machine_mode op1_mode = mode;
       rtx value;
@@ -3249,7 +3249,7 @@ expand_unop (enum machine_mode mode, optab unoptab, rtx op0, rtx target,
   libfunc = optab_libfunc (unoptab, mode);
   if (libfunc)
     {
-      rtx insns;
+      rtx_base_insn insns;
       rtx value;
       rtx eq_value;
       enum machine_mode outmode = mode;
diff --git a/gcc/rtl.h b/gcc/rtl.h
index 8ade70f..dfd4f70 100644
--- a/gcc/rtl.h
+++ b/gcc/rtl.h
@@ -2279,7 +2279,7 @@ extern rtx_base_insn get_first_nonnote_insn (void);
 extern rtx_base_insn get_last_nonnote_insn (void);
 extern void start_sequence (void);
 extern void push_to_sequence (rtx);
-extern void push_to_sequence2 (rtx, rtx);
+extern void push_to_sequence2 (rtx_base_insn, rtx_base_insn);
 extern void end_sequence (void);
 extern double_int rtx_to_double_int (const_rtx);
 extern rtx immed_double_int_const (double_int, enum machine_mode);
@@ -3012,7 +3012,7 @@ extern void init_emit_regs (void);
 extern void init_emit_once (void);
 extern void push_topmost_sequence (void);
 extern void pop_topmost_sequence (void);
-extern void set_new_first_and_last_insn (rtx, rtx);
+extern void set_new_first_and_last_insn (rtx_base_insn, rtx_base_insn);
 extern unsigned int unshare_all_rtl (void);
 extern void unshare_all_rtl_again (rtx);
 extern void unshare_all_rtl_in_chain (rtx);
-- 
1.7.11.7